property ancestor
global frameLimit, theLayer, backgroundFXSpr, currentFrame, bgdFXData, theStageBounds, dirtyFlag

on birth me
  set the ancestor of me to birth(script "recordMethods parent")
  return me
end

on record me
  if count(bgdFXData) < currentFrame then
    set previousBackgroundCast to getLast(bgdFXData)
  else
    set previousBackgroundCast to getAt(bgdFXData, currentFrame)
  end if
  set theLayer to backgroundFXSpr
  buildFilterList(me)
  set bgdFXName to getAt(curClipRecord, 2)
  set loopList to getAt(curClipRecord, 5)
  set firstClip to getAt(loopList, 1)
  set the castNum of sprite backgroundFXSpr to firstClip
  preLoadCast(getAt(loopList, 1), getLast(loopList))
  cursor(-1)
  set the loc of sprite backgroundFXSpr to point(313, 218)
  updateStage()
  repeat while the mouseUp
    set theMouseLoc to point(the mouseH, the mouseV)
    if inside(theMouseLoc, theStageBounds) then
      set the castNum of sprite backgroundFXSpr to firstClip
      set the loc of sprite backgroundFXSpr to point(313, 218)
    else
      if previousBackgroundCast <> [EMPTY, 0] then
        set the castNum of sprite backgroundFXSpr to getAt(previousBackgroundCast, 2)
        set the loc of sprite backgroundFXSpr to point(313, 218)
      else
        hideRecordingSpr(me, backgroundFXSpr)
      end if
    end if
    updateStage()
  end repeat
  set theMouseH to the mouseH
  set theMouseV to the mouseV
  set theMouseLoc to point(theMouseH, theMouseV)
  if inside(theMouseLoc, theStageBounds) then
    set countBgdFXData to count(bgdFXData)
    if countBgdFXData < currentFrame then
      repeat with theFrameNumber = countBgdFXData + 1 to currentFrame
        append(bgdFXData, [EMPTY, 0])
      end repeat
    end if
    set overFlow to 0
    repeat with theClipNumber = 1 to count(loopList)
      if currentFrame < frameLimit then
        if currentFrame > count(scoreData) then
          setAt(scoreData, currentFrame, copyList(autoHoldFrame))
        end if
        set the loc of sprite backgroundFXSpr to point(313, 218)
        set theClip to getAt(loopList, theClipNumber)
        set the castNum of sprite backgroundFXSpr to theClip
        set currentFrameData to list(bgdFXName, theClip)
        setAt(bgdFXData, currentFrame, currentFrameData)
        showFrame(playbackMgr, currentFrame, backgroundFXSpr)
        setKrusty(playbackMgr)
        incrementFrame()
        next repeat
      end if
      set overFlow to 1
      exit repeat
    end repeat
    if overFlow then
      showOverFlowDialog(me)
    end if
    cursor(4)
    extendClips(me)
    if currentFrame > 1 then
      decrementFrame()
    end if
    setKrusty(playbackMgr)
    showFrame(playbackMgr, currentFrame, 0)
    set dirtyFlag to 1
    updateTheBrain(appMgr)
    cursor(-1)
  else
    if previousBackgroundCast <> [EMPTY, 0] then
      set the castNum of sprite backgroundFXSpr to getAt(previousBackgroundCast, 2)
      set the loc of sprite backgroundFXSpr to point(313, 218)
    else
      hideRecordingSpr(me, backgroundFXSpr)
    end if
    showFrame(playbackMgr, currentFrame, 0)
    cursor(-1)
  end if
end
