global paletteVisibleP, editPaletteP, volumePaletteP, playBtnSprite, loopBtnSprite

on exitFrame
  if paletteVisibleP and not editPaletteP and not volumePaletteP then
    animate(paletteMgr)
  end if
  go(the frame)
end

on mouseDown
  hideFieldHiliterSpr(appMgr)
  if paletteVisibleP then
    hidePalette(paletteMgr)
  end if
end

on keyDown
  if the lastKey < 5 then
    hideFieldHiliterSpr(appMgr)
    if the key = "o" then
      if paletteVisibleP then
        hidePalette(paletteMgr)
      end if
      forceBtnClick(interfaceMgr, "func snd", "open hilite", point(207, 18), "openCartoon(fileMgr)")
    else
      if the key = "n" then
        if paletteVisibleP then
          hidePalette(paletteMgr)
        end if
        forceBtnClick(interfaceMgr, "func snd", "new hilite", point(108, 18), "newCartoon(appMgr)")
      else
        if the key = "s" then
          if paletteVisibleP then
            hidePalette(paletteMgr)
          end if
          forceBtnClick(interfaceMgr, "func snd", "save hilite", point(309, 18), "saveCartoon(fileMgr)")
        else
          if the key = "p" then
            if paletteVisibleP then
              hidePalette(paletteMgr)
            end if
            forcePlayBtnClick(interfaceMgr)
          else
            if the key = "l" then
              if paletteVisibleP then
                hidePalette(paletteMgr)
              end if
              loopBtnClick(interfaceMgr)
            else
              if the key = "r" then
                if paletteVisibleP then
                  hidePalette(paletteMgr)
                end if
                forceBtnClick(interfaceMgr, "rw snd", "rewind hilite", point(172, 468), "rewind(playbackMgr)")
              else
                if the keyCode = 88 then
                  if paletteVisibleP then
                    hidePalette(paletteMgr)
                  end if
                  forceBtnClick(interfaceMgr, "sf snd", "stepforward hilite", point(520, 452), "stepForward(playbackMgr)")
                else
                  if the keyCode = 124 then
                    if paletteVisibleP then
                      hidePalette(paletteMgr)
                    end if
                    forceBtnClick(interfaceMgr, "sf snd", "stepforward hilite", point(520, 452), "stepForward(playbackMgr)")
                  else
                    if the keyCode = 86 then
                      if paletteVisibleP then
                        hidePalette(paletteMgr)
                      end if
                      forceBtnClick(interfaceMgr, "sb snd", "stepback hilite", point(485, 452), "stepBack(playbackMgr)")
                    else
                      if the keyCode = 123 then
                        if paletteVisibleP then
                          hidePalette(paletteMgr)
                        end if
                        forceBtnClick(interfaceMgr, "sb snd", "stepback hilite", point(485, 452), "stepBack(playbackMgr)")
                      else
                        if the key = "q" then
                          if paletteVisibleP then
                            hidePalette(paletteMgr)
                          end if
                          forceBtnClick(interfaceMgr, "quit snd", "quit hilite", point(518, 18), "quitToolbox(appMgr)")
                        else
                          if the optionDown and (the keyCode = 118) then
                            if paletteVisibleP then
                              hidePalette(paletteMgr)
                            end if
                            forceBtnClick(interfaceMgr, "quit snd", "quit hilite", point(518, 18), "quitToolbox(appMgr)")
                          else
                            pass()
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
end
