property ancestor
global theLayer, foregroundFXSpr, theStageBounds, currentFrame, frameLimit, dirtyFlag

on birth me
  set the ancestor of me to birth(script "recordMethods parent")
  return me
end

on record me
  set theLayer to foregroundFXSpr
  buildFilterList(me)
  set theFXType to getAt(curClipRecord, 1)
  set fgdFXName to getAt(curClipRecord, 2)
  set loopList to getAt(curClipRecord, 5)
  set firstClip to getAt(loopList, 1)
  set the castNum of sprite foregroundFXSpr to firstClip
  preLoadCast(getAt(loopList, 1), getLast(loopList))
  if theFXType = "X" then
    set the loc of sprite foregroundFXSpr to point(the mouseH, the mouseV)
    updateStage()
    cursor(200)
    repeat while the mouseUp
      moveRecordingSpr(me, foregroundFXSpr, the mouseH, the mouseV)
    end repeat
  else
    set the loc of sprite foregroundFXSpr to point(313, 218)
    updateStage()
    cursor(-1)
    repeat while the mouseUp
    end repeat
  end if
  set theMouseH to the mouseH
  set theMouseV to the mouseV
  set theMouseLoc to point(theMouseH, theMouseV)
  if inside(theMouseLoc, theStageBounds) or the shiftDown then
    if theFXType = "T" then
      set theMouseH to 313
      set theMouseV to 218
    end if
    set countFgdFXData to count(fgdFXData)
    if countFgdFXData < currentFrame then
      repeat with theFrameNumber = countFgdFXData + 1 to currentFrame
        append(fgdFXData, copyList([]))
      end repeat
    end if
    set overFlow to 0
    repeat with theClipNumber = 1 to count(loopList)
      if currentFrame < frameLimit then
        if currentFrame > count(scoreData) then
          setAt(scoreData, currentFrame, copyList(autoHoldFrame))
        end if
        set the loc of sprite foregroundFXSpr to point(theMouseH, theMouseV)
        set theClip to getAt(loopList, theClipNumber)
        set the castNum of sprite foregroundFXSpr to theClip
        set currentFrameData to list(theClip, theMouseH, theMouseV, fgdFXName)
        setAt(fgdFXData, currentFrame, currentFrameData)
        showFrame(playbackMgr, currentFrame, foregroundFXSpr)
        setKrusty(playbackMgr)
        incrementFrame()
        next repeat
      end if
      set overFlow to 1
      exit repeat
    end repeat
    if overFlow then
      showOverFlowDialog(me)
    end if
    cursor(4)
    extendClips(me)
    if currentFrame > 1 then
      decrementFrame()
    end if
    setKrusty(playbackMgr)
    showFrame(playbackMgr, currentFrame, 0)
    set dirtyFlag to 1
    updateTheBrain(appMgr)
    cursor(-1)
  else
    hideRecordingSpr(me, foregroundFXSpr)
    showFrame(playbackMgr, currentFrame, 0)
    cursor(-1)
  end if
end
